gtkmm: Gtk::TreeDragDest Class Reference

gtkmm 3.24.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::TreeDragDest Class Reference
TreeView Classes

`#include <gtkmm/treedragdest.h>`

Inheritance diagram for Gtk::TreeDragDest:
[legend]

## Public Member Functions
| TreeDragDest (TreeDragDest&& src) noexcept
TreeDragDest& | operator= (TreeDragDest&& src) noexcept
| ~TreeDragDest () noexcept override
GtkTreeDragDest* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkTreeDragDest* | gobj () const
| Provides access to the underlying C GObject. More...
bool | drag_data_received (const TreeModel::Path& dest, const SelectionData& selection_data)
| Asks the Gtk::TreeDragDest to insert a row before the path dest, deriving the contents of the row from selection_data. More...
bool | row_drop_possible (const TreeModel::Path& dest_path, const SelectionData& selection_data) const
| Determines whether a drop is possible before the given dest_path, at the same depth as dest_path. More...
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void > &&slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, sigc::slot< void > &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| TreeDragDest ()
| You should derive from this class to use it. More...
virtual bool | drag_data_received_vfunc (const TreeModel::Path& dest, const SelectionData& selection_data)
virtual bool | row_drop_possible_vfunc (const TreeModel::Path& dest, const SelectionData& selection_data) const
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::TreeDragDest > | wrap (GtkTreeDragDest* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Constructor & Destructor Documentation

## ◆ TreeDragDest() [1/2]

Gtk::TreeDragDest::TreeDragDest | ( |  | ) |
| protected

You should derive from this class to use it.

## ◆ TreeDragDest() [2/2]

Gtk::TreeDragDest::TreeDragDest | ( | TreeDragDest&& | src | ) |
| noexcept

## ◆ ~TreeDragDest()

Gtk::TreeDragDest::~TreeDragDest | ( |  | ) |
| overridenoexcept

## Member Function Documentation

## ◆ add_interface()

static void Gtk::TreeDragDest::add_interface | ( | GType | gtype_implementer | ) |
| static

## ◆ drag_data_received()

bool Gtk::TreeDragDest::drag_data_received | ( | const TreeModel::Path& | dest,
|  | const SelectionData& | selection_data
| ) |  |

Asks the Gtk::TreeDragDest to insert a row before the path dest, deriving the contents of the row from selection_data.

If dest is outside the tree so that inserting before it is impossible, `false` will be returned. Also, `false` may be returned if the new row is not created for some model-specific reason. Should robustly handle a dest no longer found in the model!

Parameters

  dest | Row to drop in front of.
  selection_data | Data to drop.

Returns
  Whether a new row was created before position dest.

## ◆ drag_data_received_vfunc()

virtual bool Gtk::TreeDragDest::drag_data_received_vfunc | ( | const TreeModel::Path& | dest,
|  | const SelectionData& | selection_data
| ) |  |
| protectedvirtual

## ◆ get_type()

static GType Gtk::TreeDragDest::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkTreeDragDest* Gtk::TreeDragDest::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkTreeDragDest* Gtk::TreeDragDest::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ operator=()

TreeDragDest& Gtk::TreeDragDest::operator= | ( | TreeDragDest&& | src | ) |
| noexcept

## ◆ row_drop_possible()

bool Gtk::TreeDragDest::row_drop_possible | ( | const TreeModel::Path& | dest_path,
|  | const SelectionData& | selection_data
| ) |  | const

Determines whether a drop is possible before the given dest_path, at the same depth as dest_path.

i.e., can we drop the data in selection_data at that location. dest_path does not have to exist; the return value will almost certainly be `false` if the parent of dest_path doesn’t exist, though.

Parameters

  dest_path | Destination row.
  selection_data | The data being dragged.

Returns
  `true` if a drop is possible before dest_path.

## ◆ row_drop_possible_vfunc()

virtual bool Gtk::TreeDragDest::row_drop_possible_vfunc | ( | const TreeModel::Path& | dest,
|  | const SelectionData& | selection_data
| ) |  | const
| protectedvirtual

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::TreeDragDest > wrap | ( | GtkTreeDragDest * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.